public abstract class Poligono
{
	Lato[] lati;
	//int numLati; in java non serve, l'array lati ha la sua lunghezza

	public Poligono(int numLati)
	{
		System.out.println("Costruttore poligono con parametro");
		if(numLati < 3)
		{
			//System.err.println("Non ci puo' essere un poligono con meno di tre lati");
			//return null;
			//throw new StudiaLaGeometriaException();
			throw new RuntimeException();
		}
		lati = new Lato[numLati];
	}

	// cosi' definiamo che il poligono di default e' un triangolo
	// se non vogliamo avere un poligono di default basta omettere questo costruttore
	public Poligono()
	{
		this(3);
		System.out.println("Costruttore poligono di default");
	}

	public Lato setLato(int pos, double lung)
	{
		return this.setLato(pos, new Lato(lung));
	}

	public Lato setLato(int pos, Lato ilLato)
	{
		Lato retval = lati[pos];
		lati[pos] = ilLato;
		return retval;
	}

	public double perimetro()
	{
		double retval = 0;
		int i = 0;
		for(i=0;i<lati.length;i++)
		{
			retval += lati[i].getLunghezza();
			//retval = retval + lati[i].getLunghezza();
		}
		return retval;
	}

	public abstract double area();

	public String toString()
	{
		String retval = "Io sono un poligono con " + lati.length + " lati";
		int i = 0;
		for(i=0;i<lati.length;i++)
		{
			if(lati[i] != null)
			{
				retval = retval.concat("; il mio lato " + i + " e' lungo " + lati[i].getLunghezza());
			}
			else
			{
				retval = retval.concat("; il mio lato " + i + " e' null");
			}
		}
		return retval;
	}
}
